var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useEffect, useRef, useState } from "react";
import styled from "styled-components";
import { ic_common_attach_16_gray_0, ic_common_arrow_20_gray, ic_common_warning_16_red } from "../../common";
export var Text = function (_a) {
    var value = _a.value, onChange = _a.onChange, label = _a.label, required = _a.required, isValid = _a.isValid, placeholder = _a.placeholder, maxLength = _a.maxLength, type = _a.type;
    var _b = useState(false), isFocus = _b[0], setIsFocus = _b[1];
    var inputRef = useRef(null);
    var handleFocus = function () {
        document.activeElement === inputRef.current ? setIsFocus(true) : setIsFocus(false);
    };
    return (_jsxs(Container, __assign({ half: true, column: true }, { children: [_jsx(DynamicTitle, __assign({ onClick: function () { var _a; return (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.focus(); }, value: value, isFocus: isFocus, required: required }, { children: label }), void 0), _jsx(Input, { ref: inputRef, value: value, onChange: onChange, onFocus: handleFocus, onBlur: handleFocus, placeholder: isFocus ? placeholder : undefined, maxLength: maxLength, type: type }, void 0), _jsx(Hr, { isFocus: isFocus }, void 0), value && !isValid &&
                _jsx(InvalidMessage, { children: label + " \uD615\uC2DD\uC774 \uC798\uBABB\uB418\uC5C8\uC2B5\uB2C8\uB2E4." }, void 0)] }), void 0));
};
export var Select = function (_a) {
    var value = _a.value, show = _a.show, onClick = _a.onClick, onChange = _a.onChange, label = _a.label, options = _a.options, required = _a.required;
    var handleClick = function (e) {
        e.stopPropagation();
        onClick();
    };
    var handleSelect = function (value) {
        onChange(value);
    };
    return (_jsxs(Container, __assign({ half: true, column: true }, { children: [_jsx(Value, __assign({ style: { cursor: "pointer" }, onClick: handleClick }, { children: value }), void 0), _jsx(SelectBox, __assign({ onClick: handleClick, tabIndex: 0 }, { children: _jsx(OptionArrow, {}, void 0) }), void 0), _jsx(Option, __assign({ showOption: show }, { children: options.map(function (data, index) {
                    return (_jsx("div", __assign({ tabIndex: 0, onClick: function () { return handleSelect(data); }, style: { color: data === value ? "#fe2c54" : "#212529" } }, { children: data }), index));
                }) }), void 0), _jsx(DynamicTitle, __assign({ style: { cursor: "pointer" }, onClick: handleClick, value: value, isFocus: false, required: required }, { children: label }), void 0), _jsx(Hr, { isFocus: show, style: { marginTop: "10px" } }, void 0)] }), void 0));
};
export var File = function (_a) {
    var label = _a.label, value = _a.value, onChange = _a.onChange, required = _a.required, downloadButton = _a.downloadButton, isValid = _a.isValid, comment = _a.comment, handleFileUrl = _a.handleFileUrl, handleLink = _a.handleLink;
    var _b = useState(""), inputValue = _b[0], setInputValue = _b[1];
    var _c = useState(false), isLink = _c[0], setIsLink = _c[1];
    var _d = useState(false), isFocus = _d[0], setIsFocus = _d[1];
    var inputRef = useRef(null);
    useEffect(function () {
        if (isLink) {
            setInputValue("");
            onChange("");
        }
        return;
    }, [isLink]);
    var handleClear = function () {
        onChange("");
        setInputValue("");
    };
    return (_jsxs(Container, __assign({ column: true, style: { marginTop: "0" } }, { children: [_jsx(Title, __assign({ required: required }, { children: label }), void 0), _jsxs(ButtonGroup, { children: [_jsx(FileButton, __assign({ isLink: isLink, onClick: function () { return setIsLink(false); } }, { children: "\uCCA8\uBD80\uD558\uAE30" }), void 0), _jsx(LinkButton, __assign({ isLink: isLink, onClick: function () { return setIsLink(true); } }, { children: "\uB9C1\uD06C \uC785\uB825" }), void 0)] }, void 0), _jsxs(FileGroup, { children: [_jsxs(ClipIcon, __assign({ isLink: isLink }, { children: [!isLink && _jsx(FileLabel, { htmlFor: label }, void 0), _jsx(Input, { onFocus: function () { return setIsFocus(true); }, onBlur: function () { return setIsFocus(false); }, ref: inputRef, value: isLink ? value : inputValue, placeholder: isLink ? "https://" : label + " \uCCA8\uBD80 (PDF \uD615\uC2DD, \uCD5C\uB300 10MB)", onChange: isLink ? handleLink : handleFileUrl, disabled: !isLink }, void 0), _jsx(FileBox, { onChange: handleFileUrl, id: label }, void 0)] }), void 0), !isLink && value &&
                        _jsx("span", { className: "clear-button", onClick: handleClear }, void 0), downloadButton &&
                        _jsx("a", __assign({ href: downloadButton.link, onClick: function () { return window.open(downloadButton.link); } }, { children: _jsx("button", __assign({ onClick: function (e) { return e.preventDefault(); } }, { children: downloadButton.label }), void 0) }), void 0)] }, void 0), _jsx(Hr, { isFocus: isFocus }, void 0), value !== "" && !isValid && (_jsx(InvalidMessage, { children: label + " \uD615\uC2DD\uC774 \uC798\uBABB\uB418\uC5C8\uC2B5\uB2C8\uB2E4." }, void 0)), comment && (_jsx(Comments, { children: _jsx("span", { children: comment }, void 0) }, void 0))] }), void 0));
};
export var Agree = function (props) {
    return (_jsxs(Container, __assign({ column: true, style: { marginTop: "0" } }, { children: [_jsx(Title, { children: props.title }, void 0), _jsx(Description, { children: props.children }, void 0), _jsx(Comments, { children: props.caution.map(function (v, i) {
                    return (_jsx("span", { children: v }, i));
                }) }, void 0)] }), void 0));
};
var Container = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: relative;\n  display: flex;\n  flex-direction: ", ";\n  width: ", ";\n  margin: 20px 0;\n  \n  @media(max-width: 1150px) {\n    width: 100%;\n  }\n"], ["\n  position: relative;\n  display: flex;\n  flex-direction: ", ";\n  width: ", ";\n  margin: 20px 0;\n  \n  @media(max-width: 1150px) {\n    width: 100%;\n  }\n"])), function (_a) {
    var column = _a.column;
    return column ? "column" : "row";
}, function (_a) {
    var half = _a.half;
    return half ? "563px" : "1150px";
});
var ButtonGroup = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  position: relative;\n  width: 1150px;\n  height: 50px;\n  border: 1px solid #e2e7ed;\n  border-radius: 6px;\n  margin: 6px 0;\n\n  @media(max-width: 1150px) {\n    width: 100%;\n    height: 40px;\n  }\n"], ["\n  position: relative;\n  width: 1150px;\n  height: 50px;\n  border: 1px solid #e2e7ed;\n  border-radius: 6px;\n  margin: 6px 0;\n\n  @media(max-width: 1150px) {\n    width: 100%;\n    height: 40px;\n  }\n"])));
var Title = styled.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n    display: inline-block;\n    font-size: 14px;\n    color: #212529;\n    letter-spacing: -0.5px;\n    margin: 6px 0;\n\n    ", "\n    \n    @media(max-width: 1150px) {\n      font-size: 13px;\n    }\n"], ["\n    display: inline-block;\n    font-size: 14px;\n    color: #212529;\n    letter-spacing: -0.5px;\n    margin: 6px 0;\n\n    ", "\n    \n    @media(max-width: 1150px) {\n      font-size: 13px;\n    }\n"])), function (_a) {
    var required = _a.required;
    return required ? "\n    &:after {\n      content: '*';\n      color: #fe2c54;\n      margin-left: 0.3em;\n    }" : "";
});
var DynamicTitle = styled.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n    position: absolute;\n    top: 10px;\n    font-size: ", ";\n    color: ", ";\n    letter-spacing: -0.61px;\n    transition: .3s ease-in-out;\n    transform: ", ";\n    ", "\n    @media(max-width: 1150px) {\n      font-size: ", ";\n    }\n"], ["\n    position: absolute;\n    top: 10px;\n    font-size: ", ";\n    color: ", ";\n    letter-spacing: -0.61px;\n    transition: .3s ease-in-out;\n    transform: ", ";\n    ", "\n    @media(max-width: 1150px) {\n      font-size: ", ";\n    }\n"])), function (_a) {
    var value = _a.value, isFocus = _a.isFocus;
    return value || isFocus ? "13px" : "22px";
}, function (_a) {
    var value = _a.value, isFocus = _a.isFocus;
    return value || isFocus ? "#212529" : "#808991";
}, function (_a) {
    var value = _a.value, isFocus = _a.isFocus;
    return value || isFocus ? "translate(0px,-28px)" : "translate(0px,0px)";
}, function (_a) {
    var required = _a.required;
    return required ? "\n    &:after {\n      content: '*';\n      color: #fe2c54;\n      margin-left: 0.3em;\n    }" : "";
}, function (_a) {
    var value = _a.value, isFocus = _a.isFocus;
    return value || isFocus ? "13px" : "18px";
});
var Input = styled.input(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  width: 100%;\n  padding: 0;\n  margin: 10px 0;\n  border: none;\n  font-size: 22px;\n  outline: none;\n  background: none;\n  transition: 0.5s;\n  color: #212529;\n  text-overflow: ellipsis;\n  \n  @media(max-width: 1150px) {\n    margin: 7px 0;\n    font-size: 18px;\n  }\n\n  ::placeholder {\n    color: #808991;\n  }\n"], ["\n  width: 100%;\n  padding: 0;\n  margin: 10px 0;\n  border: none;\n  font-size: 22px;\n  outline: none;\n  background: none;\n  transition: 0.5s;\n  color: #212529;\n  text-overflow: ellipsis;\n  \n  @media(max-width: 1150px) {\n    margin: 7px 0;\n    font-size: 18px;\n  }\n\n  ::placeholder {\n    color: #808991;\n  }\n"])));
var Value = styled.div(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  position: absolute;\n  font-size: 22px;\n  white-space: nowrap;\n  overflow: hidden;\n  margin: 10px 0;\n\n  @media(max-width: 1150px) {\n    margin: 7px 0;\n    font-size: 18px;\n  }\n"], ["\n  position: absolute;\n  font-size: 22px;\n  white-space: nowrap;\n  overflow: hidden;\n  margin: 10px 0;\n\n  @media(max-width: 1150px) {\n    margin: 7px 0;\n    font-size: 18px;\n  }\n"])));
var FileGroup = styled.div(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  display: flex;\n  align-items: center;\n  margin-top: 9px;\n\n  .clear-button {\n    width: 24px;\n    height: 24px;\n    background: no-repeat center/cover url(/images/ic-common-cross-ic-line-cross-black-24.svg);\n    margin-right: 10px;\n    cursor: pointer;\n    \n    @media(max-width: 1150px) {\n      width: 20px;\n      height: 20px;\n    }\n  }\n\n  a {\n    button {\n      padding: 5px 7px 5px 4px;\n      color: #18232d;\n      font-size: 12px;\n      letter-spacing: -0.5px;\n      width: 85px;\n      border: 1px solid #dbdddf;\n      border-radius: 6px;\n      background: #fff;\n      &:before {\n        content: '';\n        background: no-repeat center/cover url(/images/ic-common-arrow-ic-line-arrow-up-black-24.svg);\n        width: 16px;\n        height: 16px;\n        margin: 0;\n      }\n    }\n  }\n"], ["\n  display: flex;\n  align-items: center;\n  margin-top: 9px;\n\n  .clear-button {\n    width: 24px;\n    height: 24px;\n    background: no-repeat center/cover url(/images/ic-common-cross-ic-line-cross-black-24.svg);\n    margin-right: 10px;\n    cursor: pointer;\n    \n    @media(max-width: 1150px) {\n      width: 20px;\n      height: 20px;\n    }\n  }\n\n  a {\n    button {\n      padding: 5px 7px 5px 4px;\n      color: #18232d;\n      font-size: 12px;\n      letter-spacing: -0.5px;\n      width: 85px;\n      border: 1px solid #dbdddf;\n      border-radius: 6px;\n      background: #fff;\n      &:before {\n        content: '';\n        background: no-repeat center/cover url(/images/ic-common-arrow-ic-line-arrow-up-black-24.svg);\n        width: 16px;\n        height: 16px;\n        margin: 0;\n      }\n    }\n  }\n"])));
var ClipIcon = styled.div(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  position: relative;\n  display: flex;\n  width: 100%;\n  align-items: center;\n  ", "\n"], ["\n  position: relative;\n  display: flex;\n  width: 100%;\n  align-items: center;\n  ", "\n"])), function (_a) {
    var isLink = _a.isLink;
    return isLink ? "\n    &:before {\n      display: inline-block;\n      content: no-close-quote;\n      background: no-repeat center/cover " + ic_common_attach_16_gray_0 + ";\n      min-width: 24px;\n      min-height: 24px;\n      margin-right: 5px;\n      margin-top: 3px;\n      @media(max-width: 1150px) {\n        margin-top: 2px;\n        margin-right: 4px;\n        min-width: 20px;\n        min-height: 20px;\n      },\n    }\n  " : "";
});
var SelectBox = styled.div(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n  cursor: pointer;\n  height: 25.6px;\n  margin: 10px 0;\n  outline: 0;\n\n  @media(max-width: 1150px) {\n    height: 20.8px;\n    margin: 7px 0;\n  }\n"], ["\n  cursor: pointer;\n  height: 25.6px;\n  margin: 10px 0;\n  outline: 0;\n\n  @media(max-width: 1150px) {\n    height: 20.8px;\n    margin: 7px 0;\n  }\n"])));
var Option = styled.div(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n  display: ", ";\n  font-size: 14px;\n  position: absolute;\n  top: 58px;\n  z-index: 1;\n  width: 100%;\n  background: white;\n  border-radius: 0 0 5px 5px;\n  box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.2);\n  cursor: pointer;\n  padding: 8px 0;\n  max-height: 300px;\n  overflow-y: scroll;\n\n  &>div {\n    outline: 0;\n    padding: 12px;\n    &:hover {\n      background: #f5f7f7;\n    }\n  }\n\n  @media(max-width: 1150px) {\n    top: 48px;\n  }\n"], ["\n  display: ", ";\n  font-size: 14px;\n  position: absolute;\n  top: 58px;\n  z-index: 1;\n  width: 100%;\n  background: white;\n  border-radius: 0 0 5px 5px;\n  box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.2);\n  cursor: pointer;\n  padding: 8px 0;\n  max-height: 300px;\n  overflow-y: scroll;\n\n  &>div {\n    outline: 0;\n    padding: 12px;\n    &:hover {\n      background: #f5f7f7;\n    }\n  }\n\n  @media(max-width: 1150px) {\n    top: 48px;\n  }\n"])), function (_a) {
    var showOption = _a.showOption;
    return showOption ? "block" : "none";
});
var OptionArrow = styled.div(templateObject_11 || (templateObject_11 = __makeTemplateObject(["\n  float: right;\n  background: no-repeat center/cover ", ";\n  width: 20px;\n  height: 20px;\n"], ["\n  float: right;\n  background: no-repeat center/cover ", ";\n  width: 20px;\n  height: 20px;\n"])), ic_common_arrow_20_gray);
var ButtonBase = styled.label.attrs({ tabIndex: 0 })(templateObject_12 || (templateObject_12 = __makeTemplateObject(["\n  position: absolute;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  width: 50%;\n  height: 50px;\n  border-radius: 6px;\n  cursor: pointer;\n  font-size: 16px;\n  top: -1px;\n  outline: 0;\n\n  @media(max-width: 1150px): {\n    font-size: 14px;\n    height: 40px;\n  }\n"], ["\n  position: absolute;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  width: 50%;\n  height: 50px;\n  border-radius: 6px;\n  cursor: pointer;\n  font-size: 16px;\n  top: -1px;\n  outline: 0;\n\n  @media(max-width: 1150px): {\n    font-size: 14px;\n    height: 40px;\n  }\n"])));
var FileLabel = styled.label(templateObject_13 || (templateObject_13 = __makeTemplateObject(["\n  position: absolute;\n  width: 100%;\n  height: 100%;\n  cursor: pointer;\n"], ["\n  position: absolute;\n  width: 100%;\n  height: 100%;\n  cursor: pointer;\n"])));
var FileButton = styled(ButtonBase)(templateObject_14 || (templateObject_14 = __makeTemplateObject(["\n    left: -1px;\n    color: ", ";\n    border: ", ";\n"], ["\n    left: -1px;\n    color: ", ";\n    border: ", ";\n"])), function (_a) {
    var isLink = _a.isLink;
    return isLink ? "#212529" : "#fe2c54";
}, function (_a) {
    var isLink = _a.isLink;
    return isLink ? "1px solid transparent" : "1px solid #fe2c54";
});
var LinkButton = styled(ButtonBase)(templateObject_15 || (templateObject_15 = __makeTemplateObject(["\n    right: -1px;\n    color: ", ";\n    border: ", ";\n"], ["\n    right: -1px;\n    color: ", ";\n    border: ", ";\n"])), function (_a) {
    var isLink = _a.isLink;
    return isLink ? "#fe2c54" : "#212529";
}, function (_a) {
    var isLink = _a.isLink;
    return isLink ? "1px solid #fe2c54" : "1px solid transparent";
});
var FileBox = styled.input.attrs({ type: "file", accept: ".pdf" })(templateObject_16 || (templateObject_16 = __makeTemplateObject(["\n  display: none;\n"], ["\n  display: none;\n"])));
var Hr = styled.div(templateObject_17 || (templateObject_17 = __makeTemplateObject(["\n    margin: 7px 0;\n    height: 2px;\n    background: ", ";\n"], ["\n    margin: 7px 0;\n    height: 2px;\n    background: ", ";\n"])), function (_a) {
    var isFocus = _a.isFocus;
    return isFocus ? "#fe2c54" : "#f5f7f7";
});
var InvalidMessage = styled.div(templateObject_18 || (templateObject_18 = __makeTemplateObject(["\n  font-size: 12px;\n  color: #fe2c54;\n  display: flex;\n  align-items: center;\n\n  &:before {\n    content: no-open-quote;\n    display: inline-block;\n    width: 16px;\n    height: 16px;\n    background: no-repeat center/cover ", ";\n    margin: auto 0px;\n    margin-right: 4px;\n  }\n"], ["\n  font-size: 12px;\n  color: #fe2c54;\n  display: flex;\n  align-items: center;\n\n  &:before {\n    content: no-open-quote;\n    display: inline-block;\n    width: 16px;\n    height: 16px;\n    background: no-repeat center/cover ", ";\n    margin: auto 0px;\n    margin-right: 4px;\n  }\n"])), ic_common_warning_16_red);
var Comments = styled.div(templateObject_19 || (templateObject_19 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: column;\n  margin: 7px 0;\n\n  & > span {\n    color: #808991;\n    font-size: 13px;\n    letter-spacing: -0.5px;\n    line-height: 18px;\n    display: flex;\n    margin: 4px 0;\n  }\n\n  & > span:before {\n    content: '\u00B7';\n    margin-right: 4px;\n    display: block;\n  }\n"], ["\n  display: flex;\n  flex-direction: column;\n  margin: 7px 0;\n\n  & > span {\n    color: #808991;\n    font-size: 13px;\n    letter-spacing: -0.5px;\n    line-height: 18px;\n    display: flex;\n    margin: 4px 0;\n  }\n\n  & > span:before {\n    content: '\u00B7';\n    margin-right: 4px;\n    display: block;\n  }\n"])));
var Description = styled.div(templateObject_20 || (templateObject_20 = __makeTemplateObject(["\n  display: flex;\n  max-width: 100%;\n  height: 144px;\n  padding: 20px;\n  margin: 6px 0;\n  font-size: 14px;\n  color: #212529;\n  line-height: 22px;\n  letter-spacing: -0.5px;\n  overflow-y: scroll;\n  border: 1px solid #e2e7ed;\n  border-radius: 6px;\n"], ["\n  display: flex;\n  max-width: 100%;\n  height: 144px;\n  padding: 20px;\n  margin: 6px 0;\n  font-size: 14px;\n  color: #212529;\n  line-height: 22px;\n  letter-spacing: -0.5px;\n  overflow-y: scroll;\n  border: 1px solid #e2e7ed;\n  border-radius: 6px;\n"])));
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11, templateObject_12, templateObject_13, templateObject_14, templateObject_15, templateObject_16, templateObject_17, templateObject_18, templateObject_19, templateObject_20;
