var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useRef, useState } from "react";
import styled from "styled-components";
import { darkgray50, redpink50, white } from "../../common";
export var NavTab = function (props) {
    var active = props.active, children = props.children, variant = props.variant, title = props.title;
    var _a = useState(false), hover = _a[0], setHover = _a[1];
    var itemContainerRef = useRef(null);
    var tabRef = useRef(null);
    var handleMouseEnter = function () {
        if (!hover) {
            setHover(true);
            setTimeout(function () {
                var itemcontainer = itemContainerRef.current;
                var tab = tabRef.current;
                if (itemcontainer && tab) {
                    itemcontainer.style.opacity = "1";
                }
            });
        }
    };
    var handleMouseLeave = function () {
        if (hover) {
            var itemcontainer = itemContainerRef.current;
            var tab = tabRef.current;
            if (itemcontainer && tab) {
                itemcontainer.style.opacity = "0";
            }
            setTimeout(function () {
                setHover(false);
            }, 200);
        }
    };
    return (_jsxs(Container, __assign({ onMouseLeave: handleMouseLeave, hover: hover }, { children: [_jsx(Tab, __assign({ active: active, variant: variant, ref: tabRef, onMouseEnter: handleMouseEnter }, { children: title }), void 0), children && hover && (_jsx(NavTabItemContainer, __assign({ ref: itemContainerRef }, { children: children }), void 0))] }), void 0));
};
var Container = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: relative;\n  display: flex;\n  align-items: center;\n\n  height: 100%;\n"], ["\n  position: relative;\n  display: flex;\n  align-items: center;\n\n  height: 100%;\n"])));
var Tab = styled.button(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  ", "\n"], ["\n  ", "\n"])), function (_a) {
    var active = _a.active, variant = _a.variant;
    var color = darkgray50;
    var borderColor = active ? redpink50 : "transparent";
    switch (variant) {
        case "black": {
            color = darkgray50;
            break;
        }
        case "white": {
            color = white;
            break;
        }
    }
    return "\n        padding: 2px;\n        height: 30px;\n        max-height: 31px;\n        background: none;\n        border: none;\n        border-bottom: 2px solid " + borderColor + ";\n        color: " + color + ";\n        border-radius: unset;\n\n        font-size: 15px;\n        font-weight: bold;\n        \n        transition: 0.2s;\n\n        &:hover {\n          border-bottom: 2px solid " + redpink50 + ";\n        }\n    ";
});
var NavTabItemContainer = styled.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  transition: 0.2s;\n\n  position: absolute;\n  top: calc(100% - 12px);\n  left: -18px;\n  padding: 20px;\n  background: ", ";\n  box-shadow: rgb(0 0 0 / 20%) 0px 2px 4px 0px;\n  border-radius: 6px;\n  opacity: 0;\n"], ["\n  transition: 0.2s;\n\n  position: absolute;\n  top: calc(100% - 12px);\n  left: -18px;\n  padding: 20px;\n  background: ", ";\n  box-shadow: rgb(0 0 0 / 20%) 0px 2px 4px 0px;\n  border-radius: 6px;\n  opacity: 0;\n"])), white);
export var NavTabItem = styled.span(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  white-space: nowrap;\n  display: block;\n  color: ", ";\n  font-size: 15px;\n  font-weight: bold;\n  cursor: pointer;\n\n  margin: 12px 0;\n  &: first-child {\n    margin-top: 0;\n  }\n  &: last-child {\n    margin-bottom: 0;\n  }\n\n  & > * {\n    color: inherit;\n  }\n\n  &: hover {\n    & > * {\n      color: ", ";\n    }\n  }\n"], ["\n  white-space: nowrap;\n  display: block;\n  color: ", ";\n  font-size: 15px;\n  font-weight: bold;\n  cursor: pointer;\n\n  margin: 12px 0;\n  &: first-child {\n    margin-top: 0;\n  }\n  &: last-child {\n    margin-bottom: 0;\n  }\n\n  & > * {\n    color: inherit;\n  }\n\n  &: hover {\n    & > * {\n      color: ", ";\n    }\n  }\n"])), function (_a) {
    var active = _a.active;
    return (active ? redpink50 : darkgray50);
}, redpink50);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
